// Code generated by go-enum DO NOT EDIT.
// Version: 0.5.6
// Revision: 97611fddaa414f53713597918c5e954646cb8623
// Build Date: 2023-03-26T21:38:06Z
// Built By: goreleaser

package find

import (
	"fmt"
	"strings"
)

const (
	// PatternTypeBasicRegexp is a PatternType of type basic-regexp.
	PatternTypeBasicRegexp PatternType = "basic-regexp"
	// PatternTypeExtendedRegexp is a PatternType of type extended-regexp.
	PatternTypeExtendedRegexp PatternType = "extended-regexp"
	// PatternTypeFixedStrings is a PatternType of type fixed-strings.
	PatternTypeFixedStrings PatternType = "fixed-strings"
	// PatternTypePerlRegexp is a PatternType of type perl-regexp.
	PatternTypePerlRegexp PatternType = "perl-regexp"
)

var ErrInvalidPatternType = fmt.Errorf("not a valid PatternType, try [%s]", strings.Join(_PatternTypeNames, ", "))

var _PatternTypeNames = []string{
	string(PatternTypeBasicRegexp),
	string(PatternTypeExtendedRegexp),
	string(PatternTypeFixedStrings),
	string(PatternTypePerlRegexp),
}

// PatternTypeNames returns a list of possible string values of PatternType.
func PatternTypeNames() []string {
	tmp := make([]string, len(_PatternTypeNames))
	copy(tmp, _PatternTypeNames)
	return tmp
}

// String implements the Stringer interface.
func (x PatternType) String() string {
	return string(x)
}

// IsValid provides a quick way to determine if the typed value is
// part of the allowed enumerated values
func (x PatternType) IsValid() bool {
	_, err := ParsePatternType(string(x))
	return err == nil
}

var _PatternTypeValue = map[string]PatternType{
	"basic-regexp":    PatternTypeBasicRegexp,
	"extended-regexp": PatternTypeExtendedRegexp,
	"fixed-strings":   PatternTypeFixedStrings,
	"perl-regexp":     PatternTypePerlRegexp,
}

// ParsePatternType attempts to convert a string to a PatternType.
func ParsePatternType(name string) (PatternType, error) {
	if x, ok := _PatternTypeValue[name]; ok {
		return x, nil
	}
	return PatternType(""), fmt.Errorf("%s is %w", name, ErrInvalidPatternType)
}
